;; Apple IIe Robot - Copyright 2019 by Michael Kohn
;; Email: mike@mikekohn.net
;;   Web: http://www.mikekohn.net/
;;
;; Function to control the forward motion of the robot.

forward:
  ;; Set motors to the same direction and turn on motors.
  ldi r17, 0x0c
  out PORTC, r17

  ldi r17, 0
  ldi r18, 0

forward_loop:

forward_wait_off:
  sbis PIND, PIN_ENC0 
  rjmp forward_wait_off

forward_wait_on:
  sbic PIND, PIN_ENC0 
  rjmp forward_wait_on

  add r17, r1
  adc r18, r0

  cpi r18, 0x19
  brne forward_loop
  cpi r17, 0x00
  brne forward_loop

  ;; Set motors to the same direction and turn off motors.
  out PORTC, r0
  ret

